VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "TestClassLister"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements ITestClassLister

Public Function ITestClassLister_TestClasses() As Collection
    Dim Components As VBComponents, Component As VBComponent
    Set ITestClassLister_TestClasses = New Collection
    Set Components = ThisWorkbook.VBProject.VBComponents
    For Each Component In Components
        If IsClassModule(Component.Type) And IsTestClassName(Component.Name) Then
            ITestClassLister_TestClasses.Add Component.Name
        End If
    Next
End Function

Public Function IsTestClassName(ComponentName As String) As Boolean
    If Len(ComponentName) <= 6 Then Exit Function
    IsTestClassName = Right(ComponentName, 6) Like "Tester"
End Function

Public Function IsClassModule(ComponentType As vbext_ComponentType) As Boolean
    IsClassModule = (ComponentType = vbext_ct_ClassModule)
End Function

Public Function ITestClassLister_NewTestClass(TestClassName As String) As ITest
    Dim Test As ITest
    Set ITestClassLister_NewTestClass = ITestClassLister_SelectTestClass(TestClassName)
    If ITestClassLister_NewTestClass Is Nothing Then Exit Function
    ITestClassLister_NewTestClass.Manager.ClassName = TestClassName
End Function

Public Function ITestClassLister_SelectTestClass(TestClassName As String) As ITest
    Select Case TestClassName
        Case "SimpleTester": Set ITestClassLister_SelectTestClass = New SimpleTester
        Case "TargetTester": Set ITestClassLister_SelectTestClass = New TargetTester
        Case Else:
    End Select
End Function

